lli  R30 FFFFh
lui  R30 0003h
jal  XBLANK
jal  XQUIT

// XBLANK blanks the screen
:XBLANK
push R31

xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
xor  R4  R4  R4
xor  R5  R5  R5
lli  R4  368      // X-Width
lli  R5  480      // Y-Width

:XBLANK0
jal  XVGA
inc  R2
brgt R2  R4  XBLANK1
br   XBLANK0

:XBLANK1
xor  R2  R2  R2
inc  R3
brgt R3  R5  XBLANK2
br   XBLANK0

:XBLANK2

pop  R31
jr   R31

// XVGA prints a pixel to the screen
// Arguments - R1 - color
//             R2 - X-position
//             R3 - Y-position
:XVGA
push R31
push R1
push R2
push R3
push R4
push R5
xor  R4 R4 R4
xor  R5 R5 R5
lli  R4 00FFh
lli  R5 01FFh
and  R1  R1  R4
and  R2  R2  R5
and  R3  R3  R5
lli  R4 8h
lli  R5 12h
sl   R2  R2  R4
sl   R3  R3  R5
or   R1  R1  R2
or   R1  R1  R3
jal  XPUTPX
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31


// XPUTPX prints a pixel using SVGA
// pixel data is taken from R1
:XPUTPX
brpix XPUTPX2
br XPUTPX
:XPUTPX2
svga R1
jr   R31

:XQUIT
stop
