xor  R3  R3  R3
xor  R4  R4  R4
xor  R1  R1  R1
lli  R1  0020h
xor  R2  R2  R2
lli  R4  000Ah
lli  R2  007Fh
lui  R30 FFFFh
:LABELA
jal  XPUTC
inc  R1
brlt R1  R2  LABELA
jal  XNWLN
inc  R3
brlt R3  R4  LABELA
nop
nop
jal  XRFDMP
:LABELB
br   LABELB
nop
nop



// XRFDMP dumps the register file to the screen
// Notes: Register 29 is not dumped.
// Memory locations 8000h - 8009h are corrupted
// by this procedure.
:XRFDMP
push R31
push R1
push R2
push R3
push R4
push R5
push R6
push R7
push R8
push R15
push R16     // context save

push R31
push R30
push R28
push R27
push R26
push R25
push R24
push R23
push R22
push R21
push R20
push R19
push R18
push R17
push R16
push R15
push R14
push R13
push R12
push R11
push R10
push R9
push R8
push R7
push R6
push R5
push R4
push R3
push R2
push R1
push R0

xor  R2  R2  R2
xor  R4  R4  R4
xor  R5  R5  R5
xor  R6  R6  R6
xor  R7  R7  R7
xor  R8  R8  R8
xor  R15 R15 R15
lli  R2  0052h   // 'R'
lli  R6  0020h   // ' '
lli  R4  003Dh   // '='
lli  R7  001Dh   // 29
lli  R8  001Fh   // 31
lli  R15 8000h

// start printing loop
:XRFDMPA
add  R1  R2  R0
jal  XPUTC       // put 'R'

add  R16 R5  R0
jal  XRG2C       // convert reg num to printable
add  R3  R15 R0
jal  XPRINT       // print register number
add  R1  R6  R0
jal  XPUTC       // print space
add  R1  R4  R0
jal  XPUTC       // print '='
add  R1  R6  R0
jal  XPUTC       // print space

pop  R16         // pop next reg to print
jal  XRG2C       // convert to printable
add  R3  R15 R0
jal  XPRINT       // print register contents
jal  XNWLN       // print new line
inc  R5          // increment current register

breq R5 R7 XRFDMP0
br   XRFDMP1
:XRFDMP0
inc  R5
:XRFDMP1
brgt R5 R8 XRFDMP2
br   XRFDMPA     // start over

:XRFDMP2

pop  R16         // context restore
pop  R15
pop  R8
pop  R7
pop  R6
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31



// XRG2C converts a register to
// a printable form (in hex)
// Arguments:
// R15 - Starting address for output
// R16 - Value that will be printed
:XRG2C
push R1
push R2
push R3
push R4
push R5
push R10
push R11
push R13
push R15
xor  R1   R1   R1
xor  R2   R2   R2
xor  R4   R4   R4
xor  R3   R3   R3
xor  R5   R5   R5
lli  R13  FFFCh
lui  R13  FFFFh
lli  R4   0004h
lli  R10  001Ch
lli  R3   0009h
lli  R1   000Fh
sw   R0   R15  9    // null terminate

:XRG2C1
srl  R11   R16  R10 // bring next nibble to LSN
and  R11   R11  R1  // isolate nibble
sub  R10   R10  R4  // subtract 4 from shift amount

// R11 is now between 0000_0000 and 0000_000F
brgt R11   R3   XRG2CA  // if char is A or greater

// char must be between 0 and 9
lli  R2   0030h
add  R11  R11   R2   // now converted to character
br   XRG2C0

:XRG2CA
lli  R2   0037h
add  R11  R11   R2   // now converted to character

:XRG2C0
sw   R11  R15   0    // store off the character
inc  R15             // go to next addr
brgt R10  R13   XRG2C1

// must be done
pop  R15
pop  R13
pop  R11
pop  R10
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
jr   R31 // return

// XNWLN prints a newline character
:XNWLN
push R31
push R1
xor  R1  R1  R1
lli  R1  000Ah        // CR char
jal  XPUTC
lli  R1  000Dh       // LF char
jal  XPUTC
pop  R1
pop  R31
jr   R31

// XPRINT reads a line from memory and
// prints it on the screen.  Starts
// looking at address specified by R3.
// Expects a null-terminated string.

:XPRINT
push R1
push R3
push R4
add  R4  R31 R0  // save return addr
:XPRINT1
lw   R1  R3  0
breq R1  R0  XPRINT2
jal  XPUTC
inc  R3
br   XPRINT1
:XPRINT2
add  R31 R4  R0
pop  R4
pop  R3
pop  R1
jr   R31

// XPUTC prints a character in R1
:XPUTC
brvid XPUTC2
br XPUTC
:XPUTC2
add R29 R1 R0
jr  R31

