nop
nop
nop
nop
nop
nop

lli  R30  FFFFh
lui  R30  0003h

jal  XBLANK

// R1 - color
// R2 - X position
// R3 - Y position

xor  R6  R6  R6
xor  R5  R5  R5
xor  R4  R4  R4
xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
lli  R4  016Fh // R4 is max X-value
lli  R6  01DFh // R6 is max Y-value
lli  R1  00FFh // initial color is white
lli  R3  0010h // initial ypos is 16
lli  R2  0010h // initial xpos is 16

:MOVER
jal  XVGA      // print the pixel
add  R17 R1 R0 // save current color
:MGET
jal  XGETC     // get user input
lli  R5 0038h
breq R1 R5 MUP
lli  R5 0034h
breq R1 R5 MLEFT
lli  R5 0036h
breq R1 R5 MRIGHT
lli  R5 0032h
breq R1 R5 MDOWN
lli  R5 0062h
breq R1 R5 MBLACK
lli  R5 0072h
breq R1 R5 MRED
lli  R5 0067h
breq R1 R5 MGREEN
lli  R5 006Ch
breq R1 R5 MBLUE
lli  R5 0079h
breq R1 R5 MYELLOW
lli  R5 006Fh
breq R1 R5 MORANGE
lli  R5 0070h
breq R1 R5 MPURPLE
lli  R5 0077h
breq R1 R5 MWHITE
lli  R5 0074h
breq R1 R5 MTEAL
lli  R5 0064h
breq R1 R5 MDGREEN
lli  R5 0069h
breq R1 R5 MIND
br MGET

:MUP
dec R3
br MFIN

:MLEFT
dec R2
br MFIN

:MRIGHT
inc R2
br MFIN

:MDOWN
inc R3
br  MFIN

:MBLACK
lli R17 0000h
br  MFIN

:MRED
lli R17 00E0h
br  MFIN

:MGREEN
lli R17 0018h
br  MFIN

:MBLUE
lli R17 0027h
br  MFIN

:MYELLOW
lli R17 00F8h
br  MFIN

:MORANGE
lli R17 00F0h
br  MFIN

:MPURPLE
lli R17 0085h
br  MFIN

:MWHITE
lli R17 00FFh
br  MFIN

:MTEAL
lli R17 001Fh
br  MFIN

:MDGREEN
lli R17 0011h
br  MFIN

:MIND
lli R17 00E6h

:MFIN
nop
nop
brlt R2 R0 XNEG
brgt R2 R4 XBIG
br XOK

:XNEG
add R2 R4 R0
br XOK

:XBIG
xor R2 R2 R2

:XOK
brlt R3 R0 YNEG
brgt R3 R6 YBIG
br YOK

:YNEG
add R3 R6 R0
br YOK

:YBIG
xor R3 R3 R3

:YOK
add R1 R17 R0  // restore color
nop
nop
nop
br MOVER

jal  XQUIT

// XBLANK blanks the screen
:XBLANK
push R31

add  R20 R31 R0

xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
xor  R4  R4  R4
xor  R5  R5  R5
lli  R4  368      // X-Width
lli  R5  480      // Y-Width

:XBLANK0
jal  XVGA
inc  R2
brgt R2  R4  XBLANK1
br   XBLANK0

:XBLANK1
xor  R2  R2  R2
inc  R3
brgt R3  R5  XBLANK2
br   XBLANK0

:XBLANK2

pop  R31

add  R31  R20 R0

nop
nop
nop
nop

jr   R31

// XVGA prints a pixel to the screen
// Arguments - R1 - color
//             R2 - X-position
//             R3 - Y-position
:XVGA
push R31
push R1
push R2
push R3
push R4
push R5
xor  R4 R4 R4
xor  R5 R5 R5
lli  R4 00FFh
lli  R5 01FFh
and  R1  R1  R4
and  R2  R2  R5
and  R3  R3  R5
lli  R4 8h
lli  R5 12h
sl   R2  R2  R4
sl   R3  R3  R5
or   R1  R1  R2
or   R1  R1  R3
jal  XPUTPX
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31


// XGETC gets a character from the user
// and returns it in R1
:XGETC
brchar XGETC2
br XGETC
:XGETC2
add  R1  R29  R0
jr  R31

// XPUTPX prints a pixel using SVGA
// pixel data is taken from R1
:XPUTPX
brpix XPUTPX2
br XPUTPX
:XPUTPX2
svga R1
jr   R31

:XQUIT
stop
