nop
nop
nop
nop
nop
nop
lli  R1  0000h
lli  R30 FFFFh
lui  R30 0003h
lui  R1  8000h
xor  R25 R25 R25
xor  R26 R26 R26 // R25 is background, R26 is foreground color
lli  R26 0018h

or   R1  R26 R1  // setup R1 for initial foreground/back setup
jal  XPUTPX      // do actual setup of init fore/back color

xor  R20 R20 R20 // R20 is the count of how many lines on screen
xor  R21 R21 R21
lli  R21 000Fh    // R21 is the max of line count

jal  XBLANK

jal XQUIT

xor  R1  R1  R1
lli  R1  000Ch
jal  XPUTC        // initial FF for returns

:SLOOP


nop
jal  SPROMPT
nop
jal  SIN       // shell in
nop
nop
brgt R20 R21  SCLEAR
lli  R1  000Dh
jal  XPUTC

nop
jal  SPROC     // process input

inc  R20

nop
br   SLOOP

:SCLEAR
nop
xor  R20 R20 R20
jal  XBLANK
nop
lli  R1  000Ch  // form feed (zeroes the cursor)
jal  XPUTC
nop

br   SLOOP

jal  XQUIT

// SPROC processes inputs
:SPROC
push R31
xor  R3  R3  R3
lui  R2  0001h
lli  R2  5000h

lw   R1  R2  0   // get first character
nop
nop
lli  R3  0063h   // c - clear
breq R1  R3 SCLEAR
lli  R3  0065h   // e - etch-a-sketch
breq R1  R3 SMP
lli  R3  0074h   // t - text color
breq R1  R3 STEXT
lli  R3  0061h   // a - aaa type flood
breq R1  R3 SAAA
lli  R3  006Ch   // l - list
breq R1  R3 SLIST

// B  a  d     c  o  m  m  a  n  d
// 42 61 64 20 63 6F 6D 6D 61 6E 64 20
lli  R1 0042h
jal  XPUTC
lli  R1 0061h
jal  XPUTC
lli  R1 0064h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0063h
jal  XPUTC
lli  R1 006Fh
jal  XPUTC
lli  R1 006Dh
jal  XPUTC
jal  XPUTC
lli  R1 0061h
jal  XPUTC
lli  R1 006Eh
jal  XPUTC
lli  R1 0064h
jal  XPUTC
lli  R1 0020h
jal  XPUTC

// o  r     f  i  l  e     n  a  m  e  
// 6F 72 20 66 69 6C 65 20 6E 61 6D 65 0A 0D
lli  R1 006Fh
jal  XPUTC
lli  R1 0072h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0066h
jal  XPUTC
lli  R1 0069h
jal  XPUTC
lli  R1 006Ch
jal  XPUTC
lli  R1 0065h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 006Eh
jal  XPUTC
lli  R1 0061h
jal  XPUTC
lli  R1 006Dh
jal  XPUTC
lli  R1 0065h
jal  XPUTC
lli  R1 000Ah
jal  XPUTC
lli  R1 000Dh
jal  XPUTC

inc  R20

nop
nop
nop

br   SPROCX

:SLIST
nop
nop
jal  LIST
br   SPROCX

:STEXT
nop
nop
lw   R3  R2  2  // get first hex val
lw   R4  R2  3  // get second
lw   R5  R2  4
lw   R6  R2  5
lui  R7  0000h
lli  R7  0004h
lui  R8  0000h
lui  R9  0000h
lui  R10 0000h
lli  R8  0037h
lli  R9  0030h
lli  R10 0039h

brgt R3 R10 SH1
sub  R3  R3 R9
br   S1DONE
:SH1
sub  R3  R3 R8
:S1DONE

brgt R4 R10 SH2
sub  R4  R4 R9
br   S2DONE
:SH2
sub  R4  R4 R8
:S2DONE

brgt R5 R10 SH3
sub  R5  R5 R9
br   S3DONE
:SH3
sub  R5  R5 R8
:S3DONE

brgt R6 R10 SH4
sub  R6  R6 R9
br   S4DONE
:SH4
sub  R6  R6 R8
:S4DONE

or   R1  R3 R0
sl   R1  R1 R7
or   R1  R1 R4
sl   R1  R1 R7
or   R1  R1 R5
sl   R1  R1 R7
or   R1  R1 R6

lui  R1  8000h
br   XPUTPX

br   SLOOP

:SAAA
nop
nop
jal  XAAA

:SMP
nop
nop
jal  MOVEPIX


:SPROCX
pop  R31
nop
nop
nop
jr   R31

// SIN listens to input from the user
:SIN
push R31
xor  R3  R3  R3
nop
nop
nop
lli  R3  0008h  // R3 is backspace
lli  R4  000Ah
lui  R4  0000h  // R4 is enter
lli  R5  0020h
lui  R5  0000h  // R5 is space
lli  R2  5000h
lui  R2  0001h  // R2 is address of input string

:SINLOOP
jal  XGETC
sw   R1  R2  0  // store typed character to memory
nop

jal  XPUTC      // echo typed character

breq R1 R3 SINBK

inc  R2

breq R1 R4 SINEN

nop
br   SINLOOP

// backspace was pressed
:SINBK
add  R1  R5  R0
jal  XPUTC      // space
add  R1  R3  R0
jal  XPUTC      // backspace
nop
br   SINLOOP

// enter was pressed
:SINEN
dec  R2
nop
nop
nop
sw   R0  R2  0  // null terminate

pop  R31
nop
nop
nop
jr   R31

// SPROMPT prints the prompt to the screen
:SPROMPT
push R31
// R  I  S  C  -  E  :
// 52 49 53 43 2D 45 3A
lli  R1  0052h
jal  XPUTC
lli  R1  0049h
jal  XPUTC
lli  R1  0053h
jal  XPUTC
lli  R1  0043h
jal  XPUTC
lli  R1  002Dh
jal  XPUTC
lli  R1  0045h
jal  XPUTC
lli  R1  003Ah
jal  XPUTC
lli  R1  0020h
jal  XPUTC

pop  R31
nop
nop
nop
jr   R31

:LIST
push R31
xor  R1 R1 R1
inc  R20
inc  R20

// a     -     A  -  F  l  o  o  d
// 61 20 2D 20 41 2D 46 6C 6F 6F 64 0A 0D
lli  R1 0061h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 002Dh
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0041h
jal  XPUTC
lli  R1 002Dh
jal  XPUTC
lli  R1 0046h
jal  XPUTC
lli  R1 006Ch
jal  XPUTC
lli  R1 006Fh
jal  XPUTC
jal  XPUTC
lli  R1 0064h
jal  XPUTC
lli  R1 000Ah
jal  XPUTC
lli  R1 000Dh
jal  XPUTC

// e     -     E  t  c  h  A  S  k  e  t  c  h
// 65 20 2D 20 45 74 63 68 41 53 6B 65 74 63 68 0A 0D
lli  R1 0065h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 002Dh
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0045h
jal  XPUTC
lli  R1 0074h
jal  XPUTC
lli  R1 0063h
jal  XPUTC
lli  R1 0068h
jal  XPUTC
lli  R1 0041h
jal  XPUTC
lli  R1 0053h
jal  XPUTC
lli  R1 006Bh
jal  XPUTC
lli  R1 0065h
jal  XPUTC
lli  R1 0074h
jal  XPUTC
lli  R1 0063h
jal  XPUTC
lli  R1 0068h
jal  XPUTC
lli  R1 000Ah
jal  XPUTC
lli  R1 000Dh
jal  XPUTC

pop  R31
nop
nop
nop
jr   R31

// XBLANK blanks the screen
:XBLANK
nop
nop
nop
push R31

xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
xor  R4  R4  R4
xor  R5  R5  R5
lli  R4  368      // X-Width
lli  R5  480      // Y-Width

:XBLANK0
jal  XVGA
inc  R2
brgt R2  R4  XBLANK1
br   XBLANK0

:XBLANK1
xor  R2  R2  R2
inc  R3
brgt R3  R5  XBLANK2
br   XBLANK0

:XBLANK2

pop  R31
nop
nop
nop
jr   R31

// XNWLN prints a newline character
:XNWLN
push R31
push R1
xor  R1  R1  R1
lli  R1  000Ah        // CR char
jal  XPUTC
lli  R1  000Dh       // LF char
jal  XPUTC
pop  R1
pop  R31
jr   R31

// XGETC gets a character from the user
// and returns it in R1
:XGETC
brchar XGETC2
br XGETC
:XGETC2
add  R1  R29  R0
jr  R31


// XPUTC prints a character in R1
:XPUTC
brvid XPUTC2
br XPUTC
:XPUTC2
add R29 R1 R0
jr  R31

// XPUTPX prints a pixel using SVGA
// pixel data is taken from R1
:XPUTPX
brpix XPUTPX2
br XPUTPX
:XPUTPX2
svga R1
jr   R31


// XVGA prints a pixel to the screen
// Arguments - R1 - color
//             R2 - X-position
//             R3 - Y-position
:XVGA
push R31
push R1
push R2
push R3
push R4
push R5
xor  R4 R4 R4
xor  R5 R5 R5
lli  R4 00FFh
lli  R5 01FFh
and  R1  R1  R4
and  R2  R2  R5
and  R3  R3  R5
lli  R4 8h
lli  R5 12h
sl   R2  R2  R4
sl   R3  R3  R5
or   R1  R1  R2
or   R1  R1  R3
jal  XPUTPX
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31

:MOVEPIX
nop
nop

jal  XBLANK

// R1 - color
// R2 - X position
// R3 - Y position

xor  R6  R6  R6
xor  R5  R5  R5
xor  R4  R4  R4
xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
lli  R4  016Fh // R4 is max X-value
lli  R6  01DFh // R6 is max Y-value
lli  R1  00FFh // initial color is white
lli  R3  0010h // initial ypos is 16
lli  R2  0010h // initial xpos is 16

:MOVER
jal  XVGA      // print the pixel
add  R17 R1 R0 // save current color
:MGET
jal  XGETC     // get user input
lli  R5 0038h
breq R1 R5 MUP
lli  R5 0034h
breq R1 R5 MLEFT
lli  R5 0036h
breq R1 R5 MRIGHT
lli  R5 0032h
breq R1 R5 MDOWN
lli  R5 0062h
breq R1 R5 MBLACK
lli  R5 0072h
breq R1 R5 MRED
lli  R5 0067h
breq R1 R5 MGREEN
lli  R5 006Ch
breq R1 R5 MBLUE
lli  R5 0079h
breq R1 R5 MYELLOW
lli  R5 006Fh
breq R1 R5 MORANGE
lli  R5 0070h
breq R1 R5 MPURPLE
lli  R5 0077h
breq R1 R5 MWHITE
lli  R5 0074h
breq R1 R5 MTEAL
lli  R5 0064h
breq R1 R5 MDGREEN
lli  R5 0069h
breq R1 R5 MIND
lli  R5 0071h // "q"
breq R1 R5 MQUIT
br MGET

:MUP
dec R3
br MFIN

:MLEFT
dec R2
br MFIN

:MRIGHT
inc R2
br MFIN

:MDOWN
inc R3
br  MFIN

:MBLACK
lli R17 0000h
br  MFIN

:MRED
lli R17 00E0h
br  MFIN

:MGREEN
lli R17 0038h
br  MFIN

:MBLUE
lli R17 0027h
br  MFIN

:MYELLOW
lli R17 00F8h
br  MFIN

:MORANGE
lli R17 00F0h
br  MFIN

:MPURPLE
lli R17 0085h
br  MFIN

:MWHITE
lli R17 00FFh
br  MFIN

:MTEAL
lli R17 001Fh
br  MFIN

:MDGREEN
lli R17 0031h
br  MFIN

:MIND
lli R17 00E6h

:MFIN
nop
nop
brlt R2 R0 XNEG
brgt R2 R4 XBIG
br XOK

:XNEG
add R2 R4 R0
br XOK

:XBIG
xor R2 R2 R2

:XOK
brlt R3 R0 YNEG
brgt R3 R6 YBIG
br YOK

:YNEG
add R3 R6 R0
br YOK

:YBIG
xor R3 R3 R3

:YOK
add R1 R17 R0  // restore color
nop
nop
nop
br MOVER

:MQUIT
nop
nop

jr R0

:XAAA
nop
nop
lui R8 8000h
lli R8 0000h
lui R2 8000h
lli R2 00FFh
xor R3 R3 R3
lui R4 0000h
lli R4 00FFh
lli R5 0100h
lui R5 0000h
lli R6 FF00h
lui R6 0000h
lli R7 00FFh
lui R7 0000h
lui R1 0000h

:LOOPA
lli R1 0061h	//a
jal XPUTC
jal XPUTPX3
dec R4          // dec text color
and R4  R4  R7  // keep in bounds
add R3  R3  R5  // inc background color
and R3  R3  R6  // keep in bounds
or  R2  R3  R4
or  R2  R2  R8  // setup new pixel
brchar XAAAX
br LOOPA
:XAAAX
add R0  R29 R0  // it doesn't matter...
nop
nop
jr  R0

:XPUTPX3
brpix XPUTPX4
br XPUTPX3
:XPUTPX4
svga R2
jr   R31


:XQUIT
nop
nop
stop
