nop
nop
nop
nop
nop
nop
lli  R1  0000h
lli  R30 FFFFh
lui  R30 0003h
lui  R1  8000h
xor  R25 R25 R25
xor  R26 R26 R26 // R25 is background, R26 is foreground color
lli  R26 0018h

or   R1  R26 R1  // setup R1 for initial foreground/back setup
jal  XPUTPX      // do actual setup of init fore/back color

xor  R20 R20 R20 // R20 is the count of how many lines on screen
xor  R21 R21 R21
lli  R21 000Fh    // R21 is the max of line count

jal  XBLANK

xor  R1  R1  R1
lli  R1  000Ch
jal  XPUTC        // initial FF for returns

:SLOOP


nop
jal  SPROMPT
nop
jal  SIN       // shell in
nop
nop
brgt R20 R21  SCLEAR
lli  R1  000Dh
jal  XPUTC

nop
jal  SPROC     // process input

inc  R20

nop
br   SLOOP

:SCLEAR
nop
xor  R20 R20 R20
jal  XBLANK
nop
lli  R1  000Ch  // form feed (zeroes the cursor)
jal  XPUTC
nop

br   SLOOP

jal  XQUIT

// SPROC processes inputs
:SPROC
push R31
xor  R3  R3  R3
lui  R2  0001h
lli  R2  5000h

lw   R1  R2  0   // get first character
nop
nop
lli  R3  0063h   // c - clear
breq R1  R3 SCLEAR
lli  R3  0065h   // e - etch-a-sketch
breq R1  R3 SMP
lli  R3  0074h   // t - text color
breq R1  R3 STEXT
lli  R3  0061h   // a - aaa type flood
breq R1  R3 SAAA
lli  R3  0070h   // p - PONG!
breq R1  R3 SPONG
lli  R3  0068h   // h - hard PONG!
breq R1  R3 SHPONG
lli  R3  006Ch   // l - list
breq R1  R3 SLIST

nop
nop
nop

br   SPROCX

:SLIST
nop
nop
jal  LIST
br   SPROCX

:STEXT
nop
nop
lw   R3  R2  2  // get first hex val
lw   R4  R2  3  // get second
lw   R5  R2  4
lw   R6  R2  5
lui  R7  0000h
lli  R7  0004h
lui  R8  0000h
lui  R9  0000h
lui  R10 0000h
lli  R8  0037h
lli  R9  0030h
lli  R10 0039h

brgt R3 R10 SH1
sub  R3  R3 R9
br   S1DONE
:SH1
sub  R3  R3 R8
:S1DONE

brgt R4 R10 SH2
sub  R4  R4 R9
br   S2DONE
:SH2
sub  R4  R4 R8
:S2DONE

brgt R5 R10 SH3
sub  R5  R5 R9
br   S3DONE
:SH3
sub  R5  R5 R8
:S3DONE

brgt R6 R10 SH4
sub  R6  R6 R9
br   S4DONE
:SH4
sub  R6  R6 R8
:S4DONE

or   R1  R3 R0
sl   R1  R1 R7
or   R1  R1 R4
sl   R1  R1 R7
or   R1  R1 R5
sl   R1  R1 R7
or   R1  R1 R6

lui  R1  8000h
br   XPUTPX

br   SLOOP

:SAAA
nop
nop
jal  XAAA

:SMP
nop
nop
jal  MOVEPIX

:SPONG
nop
nop
jal  PONG1

:SHPONG
nop
nop
jal  PONG1


:SPROCX
pop  R31
nop
nop
nop
jr   R31

// SIN listens to input from the user
:SIN
push R31
xor  R3  R3  R3
nop
nop
nop
lli  R3  0008h  // R3 is backspace
lli  R4  000Ah
lui  R4  0000h  // R4 is enter
lli  R5  0020h
lui  R5  0000h  // R5 is space
lli  R2  5000h
lui  R2  0001h  // R2 is address of input string

:SINLOOP
jal  XGETC
sw   R1  R2  0  // store typed character to memory
nop

jal  XPUTC      // echo typed character

breq R1 R3 SINBK

inc  R2

breq R1 R4 SINEN

nop
br   SINLOOP

// backspace was pressed
:SINBK
add  R1  R5  R0
jal  XPUTC      // space
add  R1  R3  R0
jal  XPUTC      // backspace
nop
br   SINLOOP

// enter was pressed
:SINEN
dec  R2
nop
nop
nop
sw   R0  R2  0  // null terminate

pop  R31
nop
nop
nop
jr   R31

// SPROMPT prints the prompt to the screen
:SPROMPT
push R31
// R  I  S  C  -  E  :
// 52 49 53 43 2D 45 3A
lli  R1  0052h
jal  XPUTC
lli  R1  0049h
jal  XPUTC
lli  R1  0053h
jal  XPUTC
lli  R1  0043h
jal  XPUTC
lli  R1  002Dh
jal  XPUTC
lli  R1  0045h
jal  XPUTC
lli  R1  003Ah
jal  XPUTC
lli  R1  0020h
jal  XPUTC

pop  R31
nop
nop
nop
jr   R31

:LIST
push R31
xor  R1 R1 R1
inc  R20
inc  R20
inc  R20
inc  R20
// a     -     A  -  F  l  o  o  d
// 61 20 2D 20 41 2D 46 6C 6F 6F 64 0A 0D
lli  R1 0061h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 002Dh
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0041h
jal  XPUTC
lli  R1 002Dh
jal  XPUTC
lli  R1 0046h
jal  XPUTC
lli  R1 006Ch
jal  XPUTC
lli  R1 006Fh
jal  XPUTC
jal  XPUTC
lli  R1 0064h
jal  XPUTC
lli  R1 000Ah
jal  XPUTC
lli  R1 000Dh
jal  XPUTC

// e     -     E  t  c  h  A  S  k  e  t  c  h
// 65 20 2D 20 45 74 63 68 41 53 6B 65 74 63 68 0A 0D
lli  R1 0065h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 002Dh
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0045h
jal  XPUTC
lli  R1 0074h
jal  XPUTC
lli  R1 0063h
jal  XPUTC
lli  R1 0068h
jal  XPUTC
lli  R1 0041h
jal  XPUTC
lli  R1 0053h
jal  XPUTC
lli  R1 006Bh
jal  XPUTC
lli  R1 0065h
jal  XPUTC
lli  R1 0074h
jal  XPUTC
lli  R1 0063h
jal  XPUTC
lli  R1 0068h
jal  XPUTC
lli  R1 000Ah
jal  XPUTC
lli  R1 000Dh
jal  XPUTC

// p     -     P  O  N  G  !
// 70 20 2D 20 50 4F 4E 47 21 0A 0D
lli  R1 0070h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 002Dh
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0050h
jal  XPUTC
lli  R1 004Fh
jal  XPUTC
lli  R1 004Eh
jal  XPUTC
lli  R1 0047h
jal  XPUTC
lli  R1 0021h
jal  XPUTC
lli  R1 000Ah
jal  XPUTC
lli  R1 000Dh
jal  XPUTC

// h     -     H  a  r  d  P  O  N  G  !
// 68 20 2D 20 48 61 72 64 PONG0A0D
lli  R1 0068h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 002Dh
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0048h
jal  XPUTC
lli  R1 0061h
jal  XPUTC
lli  R1 0072h
jal  XPUTC
lli  R1 0064h
jal  XPUTC
lli  R1 0020h
jal  XPUTC
lli  R1 0050h
jal  XPUTC
lli  R1 004Fh
jal  XPUTC
lli  R1 004Eh
jal  XPUTC
lli  R1 0047h
jal  XPUTC
lli  R1 0021h
jal  XPUTC
lli  R1 000Ah
jal  XPUTC
lli  R1 000Dh
jal  XPUTC


pop  R31
nop
nop
nop
jr   R31

// XBLANK blanks the screen
:XBLANK
nop
nop
nop
push R31

xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
xor  R4  R4  R4
xor  R5  R5  R5
lli  R4  368      // X-Width
lli  R5  480      // Y-Width

:XBLANK0
jal  XVGA
inc  R2
brgt R2  R4  XBLANK1
br   XBLANK0

:XBLANK1
xor  R2  R2  R2
inc  R3
brgt R3  R5  XBLANK2
br   XBLANK0

:XBLANK2

pop  R31
nop
nop
nop
jr   R31

// XNWLN prints a newline character
:XNWLN
push R31
push R1
xor  R1  R1  R1
lli  R1  000Ah        // CR char
jal  XPUTC
lli  R1  000Dh       // LF char
jal  XPUTC
pop  R1
pop  R31
jr   R31

// XGETC gets a character from the user
// and returns it in R1
:XGETC
brchar XGETC2
br XGETC
:XGETC2
add  R1  R29  R0
jr  R31


// XPUTC prints a character in R1
:XPUTC
brvid XPUTC2
br XPUTC
:XPUTC2
add R29 R1 R0
jr  R31

// XPUTPX prints a pixel using SVGA
// pixel data is taken from R1
:XPUTPX
brpix XPUTPX2
br XPUTPX
:XPUTPX2
svga R1
jr   R31


// XVGA prints a pixel to the screen
// Arguments - R1 - color
//             R2 - X-position
//             R3 - Y-position
:XVGA
push R31
push R1
push R2
push R3
push R4
push R5
xor  R4 R4 R4
xor  R5 R5 R5
lli  R4 00FFh
lli  R5 01FFh
and  R1  R1  R4
and  R2  R2  R5
and  R3  R3  R5
lli  R4 8h
lli  R5 12h
sl   R2  R2  R4
sl   R3  R3  R5
or   R1  R1  R2
or   R1  R1  R3
jal  XPUTPX
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31

:MOVEPIX
nop
nop

jal  XBLANK

// R1 - color
// R2 - X position
// R3 - Y position

xor  R6  R6  R6
xor  R5  R5  R5
xor  R4  R4  R4
xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
lli  R4  016Fh // R4 is max X-value
lli  R6  01DFh // R6 is max Y-value
lli  R1  00FFh // initial color is white
lli  R3  0010h // initial ypos is 16
lli  R2  0010h // initial xpos is 16

:MOVER
jal  XVGA      // print the pixel
add  R17 R1 R0 // save current color
:MGET
jal  XGETC     // get user input
lli  R5 0038h
breq R1 R5 MUP
lli  R5 0034h
breq R1 R5 MLEFT
lli  R5 0036h
breq R1 R5 MRIGHT
lli  R5 0032h
breq R1 R5 MDOWN
lli  R5 0062h
breq R1 R5 MBLACK
lli  R5 0072h
breq R1 R5 MRED
lli  R5 0067h
breq R1 R5 MGREEN
lli  R5 006Ch
breq R1 R5 MBLUE
lli  R5 0079h
breq R1 R5 MYELLOW
lli  R5 006Fh
breq R1 R5 MORANGE
lli  R5 0070h
breq R1 R5 MPURPLE
lli  R5 0077h
breq R1 R5 MWHITE
lli  R5 0074h
breq R1 R5 MTEAL
lli  R5 0064h
breq R1 R5 MDGREEN
lli  R5 0069h
breq R1 R5 MIND
lli  R5 0071h // "q"
breq R1 R5 MQUIT
br MGET

:MUP
dec R3
br MFIN

:MLEFT
dec R2
br MFIN

:MRIGHT
inc R2
br MFIN

:MDOWN
inc R3
br  MFIN

:MBLACK
lli R17 0000h
br  MFIN

:MRED
lli R17 00E0h
br  MFIN

:MGREEN
lli R17 0038h
br  MFIN

:MBLUE
lli R17 0027h
br  MFIN

:MYELLOW
lli R17 00F8h
br  MFIN

:MORANGE
lli R17 00F0h
br  MFIN

:MPURPLE
lli R17 0085h
br  MFIN

:MWHITE
lli R17 00FFh
br  MFIN

:MTEAL
lli R17 001Fh
br  MFIN

:MDGREEN
lli R17 0031h
br  MFIN

:MIND
lli R17 00E6h

:MFIN
nop
nop
brlt R2 R0 XNEG
brgt R2 R4 XBIG
br XOK

:XNEG
add R2 R4 R0
br XOK

:XBIG
xor R2 R2 R2

:XOK
brlt R3 R0 YNEG
brgt R3 R6 YBIG
br YOK

:YNEG
add R3 R6 R0
br YOK

:YBIG
xor R3 R3 R3

:YOK
add R1 R17 R0  // restore color
nop
nop
nop
br MOVER

:MQUIT
nop
nop

jr R0

:XAAA
nop
nop
lui R8 8000h
lli R8 0000h
lui R2 8000h
lli R2 00FFh
xor R3 R3 R3
lui R4 0000h
lli R4 00FFh
lli R5 0100h
lui R5 0000h
lli R6 FF00h
lui R6 0000h
lli R7 00FFh
lui R7 0000h
lui R1 0000h

:LOOPA
lli R1 0061h	//a
jal XPUTC
jal XPUTPX3
dec R4          // dec text color
and R4  R4  R7  // keep in bounds
add R3  R3  R5  // inc background color
and R3  R3  R6  // keep in bounds
or  R2  R3  R4
or  R2  R2  R8  // setup new pixel
brchar XAAAX
br LOOPA
:XAAAX
add R0  R29 R0  // it doesn't matter...
nop
nop
jr  R0

:XPUTPX3
brpix XPUTPX4
br XPUTPX3
:XPUTPX4
svga R2
jr   R31

//PONG!
//do not corrupt theses regs
//R20 - top paddle xpos(left side)
//R21 - bottom paddle xpos(left side)
//R27 - ball center xpos
//R28 - ball center ypos
//R23 - ball x-speed positive is right
//R24 - ball y-speed positive is down
//R25 - timer counter
//R16 - z char
//R17 - x char
//R18 - < char
//R19 - > char
//R14 - left edge for paddle = 3
//R15 - right edge for paddle= 305
//R12 - top paddle ypos - ball vert rad = 8
//R13 - bottom paddle ypos - ball vert rad = 471
//R6 - game speed
//R8 - Top score
//R9 - Bottom score
//R10 - left edge for ball = 6
//R11 - right edge for ball = 362
//initial nops just in case
:PONG1
nop
nop
nop
nop
nop
nop
:ZSTART
//init score
xor R8 R8 R8
xor R9 R9 R9

:START
//form feed
lli R1 12
jal XPUTC

//blank screen
jal ZBLANK

//print pong
jal ZPONG
//initialize edges
xor R10 R10 R10
xor R11 R11 R11
xor R13 R13 R13
xor R12 R12 R12
xor R14 R14 R14
xor R15 R15 R15
lli R10 5
lli R11 362
nop
nop
nop
nop
lli R13 470
nop
nop
nop
nop
lli R12 8
lli R14 2
lli R15 305
inc R10
nop
nop
nop
inc R14

//initialize chars
xor R16 R16 R16
xor R17 R17 R17
xor R18 R18 R18
xor R19 R19 R19
lli R16 122
lli R17 120
lli R18 44
lli R19 46

//draw edges
push R10
push R11
push R12
push R13
push R14
push R15
xor R10 R10 R10
xor R11 R11 R11
xor R12 R12 R12
xor R13 R13 R13
xor R14 R14 R14
xor R15 R15 R15
lli R12 2
lli R13 479
lli R14 00E0h
lli R15 00E0h
jal XSQRF
lli R10 366
lli R12 368
jal XSQRF
pop R15
pop R14
pop R13
pop R12
pop R11
pop R10

//draw paddles
xor R5 R5 R5
xor R6 R6 R6
xor R7 R7 R7
lli R5 153	//centered on top
lli R7 00E0h
jal ZPAD
lli R6 475	//centered on bottom
jal ZPAD

//draw ball
xor R27 R27 R27
xor R7 R7 R7
lli R27 183	//centered horizontal
add R28 R12 R0	//at top paddle
lli R7 00FFh	//white ball
add R5 R27 R0
add R6 R28 R0
jal ZBALL
jal XGETC	//wait for input
//blank text
jal ZBLAN2
//draw edges
push R10
push R11
push R12
push R13
push R14
push R15
xor R10 R10 R10
xor R11 R11 R11
xor R12 R12 R12
xor R13 R13 R13
xor R14 R14 R14
xor R15 R15 R15
lli R12 2
lli R13 479
lli R14 00E0h
lli R15 00E0h
jal XSQRF
lli R10 366
lli R12 368
jal XSQRF
pop R15
pop R14
pop R13
pop R12
pop R11
pop R10
//draw paddles
xor R5 R5 R5
xor R6 R6 R6
xor R7 R7 R7
lli R5 153	//centered on top
lli R7 00E0h
jal ZPAD
lli R6 475	//centered on bottom
jal ZPAD
//draw ball
add R5 R27 R0
add R6 R28 R0
lli R7 7	//blue ball
lli R7 0007h
jal ZBALL
//initialize ball speed
xor R23 R23 R23
xor R24 R24 R24
lli R23 1
lli R24 1
//initialize paddle pos
xor R5 R5 R5
xor R7 R7 R7
xor R20 R20 R20
xor R21 R21 R21
lli R20 153
lli R21 153
lli R7 480
nop
nop
nop
lli R5 2
nop
nop
nop
lli R6 1500	//counter
nop
nop
nop
sl R6 R6 R5
//run loop
:ZMAIN
//move ball
jal ZMBALL
//move paddles
jal ZMPAD
//check boundries
brlt R28 R0 SCOREB
nop
nop
nop
nop
nop
brgt R28 R7 SCORET
br ZMAIN
//end of program
br XQUIT
//top score = R8
:SCORET
inc R8
xor R1 R1 R1
lli R1 9
breq R1 R8 GAMET
jal PSCORE
br START
//bottom score = R9
:SCOREB
inc R9
xor R1 R1 R1
lli R1 9
breq R1 R9 GAMEB
jal PSCORE
br START
//Top Wins
:GAMET
jal PSCORE
lli R1 12
jal XPUTC
lli R2 21
lli R1 10
:GAMET1
jal XPUTC
dec R2
brgt R2 R0 GAMET1
lli R1 32
lli R2 18
:GAMET2
jal XPUTC
dec R2
brgt R2 R0 GAMET2
lli R1 84	//T
jal XPUTC
lli R1 111	//o
jal XPUTC
lli R1 112	//p
jal XPUTC
lli R1 32	// 
jal XPUTC
lli R1 87	//W
jal XPUTC
lli R1 105	//i
jal XPUTC
lli R1 110	//n
jal XPUTC
lli R1 115	//s
jal XPUTC
lli R1 33	//!
jal XPUTC
jal XGETC
br ZSTART
//Bottom Wins
:GAMEB
jal PSCORE
lli R1 12
jal XPUTC
lli R2 21
lli R1 10
:GAMEB1
jal XPUTC
dec R2
brgt R2 R0 GAMEB1
lli R1 32
lli R2 17
:GAMEB2
jal XPUTC
dec R2
brgt R2 R0 GAMEB2
lli R1 66	//B
jal XPUTC
lli R1 111	//o
jal XPUTC
lli R1 116	//t
jal XPUTC
jal XPUTC	//t
lli R1 111	//o
jal XPUTC
lli R1 109	//m
jal XPUTC
lli R1 32	// 
jal XPUTC
lli R1 87	//W
jal XPUTC
lli R1 105	//i
jal XPUTC
lli R1 110	//n
jal XPUTC
lli R1 115	//s
jal XPUTC
lli R1 33	//!
jal XPUTC
jal XGETC
br ZSTART
//prints score and ends game if neccesary
:PSCORE
push R8
push R9
push R1
push R2
push R31
lli R1 12
jal XPUTC
xor R2 R2 R2
lli R2 48
add R8 R8 R2	//convert to ascii
add R9 R9 R2
jal ZBLANK
lli R2 22
lli R1 10	//newline
:PSCOR1
jal XPUTC
dec R2
brgt R2 R0 PSCOR1
lli R1 32	//space
lli R2 20
:PSCOR2
jal XPUTC
dec R2
brgt R2 R0 PSCOR2
lli R1 83	//S
jal XPUTC
lli R1 67	//C
jal XPUTC
lli R1 79	//O
jal XPUTC
lli R1 82	//R
jal XPUTC
lli R1 69	//E
jal XPUTC
lli R1 33	//!
jal XPUTC
lli R1 13	//cr
jal XPUTC
lli R1 10	//newline
jal XPUTC
lli R1 32
lli R2 19
:PSCOR3
jal XPUTC
dec R2
brgt R2 R0 PSCOR3
lli R1 84	//T
jal XPUTC
lli R1 111	//o
jal XPUTC
lli R1 112	//p
jal XPUTC
lli R1 32	//space
jal XPUTC
lli R1 45	//-
jal XPUTC
lli R1 32	//space
jal XPUTC
add R1 R8 R0	//score
jal XPUTC
lli R1 13	//cr
jal XPUTC
lli R1 10	//newline
jal XPUTC
lli R1 32	//space
lli R2 18
:PSCOR4
jal XPUTC
dec R2
brgt R2 R0 PSCOR4
lli R1 66	//B
jal XPUTC
lli R1 111	//o
jal XPUTC
lli R1 116	//t
jal XPUTC
jal XPUTC	//t
lli R1 111	//o
jal XPUTC
lli R1 109	//m
jal XPUTC
lli R1 32	// 
jal XPUTC
lli R1 45	//-
jal XPUTC
lli R1 32	// 
jal XPUTC
add R1 R9 R0	//score
jal XPUTC
jal XGETC	//wait for input
pop R31
pop R2
pop R1
pop R9
pop R8
jr R31

//Timed version of getc
//clk 8.75 MHz
//1 sec per bottom to top = 8.75*10^6 inst per frame
//18229 inst per pixel / by six to get counter
:XGETCT
push R2
add R2 R6 R0
xor R1 R1 R1
:XGETT
brchar XGETT2
dec R2
nop
breq R2 R0 XGETT4
br XGETT
:XGETT2
add  R1  R29  R0
:XGETT3
dec R2
breq R2 R0 XGETT4
br XGETT3
:XGETT4
pop R2
jr  R31

//moves the ball
//xspeed in R23
//yspeed in R24
//xpos in R27
//ypos in R28
//top paddle left at R20
//bottom paddle at R21
:ZMBALL
push R5
push R7
push R31
push R6
//blank ball
add R5 R27 R0
add R6 R28 R0
xor R7 R7 R7
lli R7 0
jal ZBALL
//mov ypos
brgt R24 R0 ZYPOS //speed is down
brgt R28 R12 ZYMOV	//not at top
xor R5 R5 R5
nop
nop
nop
lli R5 3
nop
nop
nop
sub R6 R20 R5
nop
nop
nop
brlt R27 R6 ZYMOV	//misses to the left
nop
nop
nop
lli R5 63
nop
nop
nop
add R6 R20 R5
nop
nop
nop
brgt R27 R6 ZYMOV	//misses to the right
sub R24 R0 R24	//invert speed if at paddle
nop
nop
pop R6
lli R5 00ffh
nop
nop
nop
sub R6 R6 R5
nop
nop
nop
push R6
br ZYMOV
:ZYPOS
brlt R28 R13 ZYMOV	//not at bottom
xor R5 R5 R5
nop
nop
nop
lli R5 3
nop
nop
nop
sub R6 R21 R5
nop
nop
nop
brlt R27 R6 ZYMOV	//misses to the left
nop
nop
nop
lli R5 63
nop
nop
nop
add R6 R21 R5
nop
nop
nop
brgt R27 R6 ZYMOV	//misses to the right
sub R24 R0 R24	//invert speed if at paddle
nop
nop
pop R6
lli R5 007fh
nop
nop
nop
sub R6 R6 R5
nop
nop
nop
push R6
:ZYMOV
add R28 R28 R24	//modify ypos
//mov xpos
brgt R23 R0 ZXPOS //speed is right
brgt R27 R10 ZXMOV	//not at right
sub R23 R0 R23	//invert speed if at wall
br ZXMOV
:ZXPOS
brlt R27 R11 ZXMOV	//not at right
sub R23 R0 R23	//invert speed if at wall
:ZXMOV
add R27 R27 R23	//modify xpos
add R5 R27 R0
add R6 R28 R0
lli R7 00FFh
jal ZBALL
pop R6
pop R31
pop R7
pop R5
jr R31


//gets input and moves paddles
//z moves bottom to the left
//x moves bottom to the right
//< moves top to the left
//> moves top to the right
:ZMPAD
push R31
jal XGETCT	//timed input
//jal XGETC
breq R1 R16 ZMBL	//move bottom left
breq R1 R17 ZMBR	//move bottom right
breq R1 R18 ZMTL	//move top left
breq R1 R19 ZMTR	//move top right
:ZMPAD1
pop R31
nop
nop
jr R31

//moves bottom left
:ZMBL
push R5
push R6
push R7
push R2
nop
nop
nop
lli R2 12
nop
nop
nop
xor R5 R5 R5
xor R6 R6 R6
xor R7 R7 R7
add R5 R21 R0
lli R6 475
lli R7 0	//clear paddle
jal ZPAD
:ZMBL2
breq R21 R14 ZMBL1	//check for left edge
nop
nop
nop
dec R21
dec R5
dec R2
nop
nop
nop
brgt R2 R0 ZMBL2
nop
nop
nop
:ZMBL1
lli R7 00E0h	//red
jal ZPAD
nop
nop
nop
pop R2
pop R7
pop R6
pop R5
br ZMPAD1

//moves bottom right
:ZMBR
push R5
push R6
push R7
push R2
nop
nop
nop
lli R2 12
nop
nop
nop
xor R5 R5 R5
xor R6 R6 R6
xor R7 R7 R7
add R5 R21 R0
lli R6 475
lli R7 0	//clear paddle
jal ZPAD
:ZMBR2
breq R21 R15 ZMBR1	//check for right edge
nop
nop
nop
inc R21
inc R5
dec R2
nop
nop
nop
brgt R2 R0 ZMBR2
nop
nop
nop
:ZMBR1
lli R7 00E0h	//red
jal ZPAD
nop
nop
nop
pop R2
pop R7
pop R6
pop R5
br ZMPAD1

//moves top left
:ZMTL
push R5
push R6
push R7
push R2
nop
nop
nop
lli R2 12
nop
nop
nop
xor R5 R5 R5
xor R6 R6 R6
xor R7 R7 R7
add R5 R20 R0
lli R7 0	//clear paddle
jal ZPAD
:ZMTL2
breq R20 R14 ZMTL1	//check for left edge
nop
nop
nop
dec R20
dec R5
dec R2
nop
nop
nop
brgt R2 R0 ZMTL2
nop
nop
nop
:ZMTL1
lli R7 00E0h	//red
jal ZPAD
nop
nop
nop
pop R2
pop R7
pop R6
pop R5
br ZMPAD1

//moves top right
:ZMTR
push R5
push R6
push R7
push R2
nop
nop
nop
lli R2 12
nop
nop
nop
xor R5 R5 R5
xor R6 R6 R6
xor R7 R7 R7
add R5 R20 R0
lli R7 0	//clear paddle
jal ZPAD
:ZMTR2
breq R20 R15 ZMTR1	//check for right edge
nop
nop
nop
inc R20
inc R5
dec R2
nop
nop
nop
brgt R2 R0 ZMTR2
nop
nop
nop
:ZMTR1
lli R7 00E0h	//red
jal ZPAD
nop
nop
nop
pop R2
pop R7
pop R6
pop R5
br ZMPAD1

//draw paddles
//upper left xpos in R5
//upper left ypos in R6
//color in R7
//width = 60 pix
//height = 4 pix
:ZPAD
push R10
push R11
push R12
push R13
push R14
push R15
push R16
push R31
xor R10 R10 R10
xor R11 R11 R11
xor R12 R12 R12
xor R13 R13 R13
xor R16 R16 R16
add R10 R5 R0
add R11 R6 R0
add R14 R7 R0
add R15 R7 R0
nop
nop
nop
lli R16 59
nop
nop
nop
add R12 R10 R16
nop
nop
nop
lli R16 3
nop
nop
nop
add R13 R11 R16
jal XSQRF
pop R31
pop R16
pop R15
pop R14
pop R13
pop R12
pop R11
pop R10
jr R31

//ZPONG prints pong and waits for keypress
:ZPONG
push R1
push R2
push R31
xor R2 R2 R2
lli R2 23
lli R1 10	//newline
:ZPONG1
jal XPUTC	//prints 23 newlines
dec R2
brgt R2 R0 ZPONG1
lli R1 32	//space
lli R2 20	//prints 20 spaces
:ZPONG2
jal XPUTC
dec R2
brgt R2 R0 ZPONG2
lli R1 80	//P
jal XPUTC
lli R1 79	//O
jal XPUTC
lli R1 78	//N
jal XPUTC
lli R1 71	//G
jal XPUTC
lli R1 33	//!
jal XPUTC
lli R1 10	//newline
jal XPUTC
jal XPUTC
lli R1 13	//carriage return
jal XPUTC
lli R1 32	//space
lli R2 11
:ZPONG3
jal XPUTC	//prints 11 spaces
dec R2
brgt R2 R0 ZPONG3
lli R1 80	//P
jal XPUTC
lli R1 114	//r
jal XPUTC
lli R1 101	//e
jal XPUTC
lli R1 115	//s
jal XPUTC
jal XPUTC	//s
lli R1 32	// 
jal XPUTC
lli R1 65	//A
jal XPUTC
lli R1 32	// 
jal XPUTC
lli R1 75	//K
jal XPUTC
lli R1 101	//e
jal XPUTC
lli R1 121	//y
jal XPUTC
lli R1 32	// 
jal XPUTC
lli R1 84	//T
jal XPUTC
lli R1 111	//o
jal XPUTC
lli R1 32	// 
jal XPUTC
lli R1 67	//C
jal XPUTC
lli R1 111	//o
jal XPUTC
lli R1 110	//n
jal XPUTC
lli R1 116	//t
jal XPUTC
lli R1 105	//i
jal XPUTC
lli R1 110	//n
jal XPUTC
lli R1 117	//u
jal XPUTC
lli R1 101	//e
jal XPUTC
pop R31
pop R2
pop R1
jr R31


//ZBLANK blanks screen
:ZBLANK
push R10
push R11
push R12
push R13
push R14
push R15
push R31
xor R14 R14 R14
xor R15 R15 R15
xor R10 R10 R10
xor R11 R11 R11
lli R12 368
lui R12 0
lli R13 482
lui R13 0
jal XSQRF
pop R31
pop R15
pop R14
pop R13
pop R12
pop R11
pop R10
jr R31

//ZBLAN2 blanks center
:ZBLAN2
push R10
push R11
push R12
push R13
push R14
push R15
push R31
xor R10 R10 R10
xor R11 R11 R11
xor R14 R14 R14
xor R15 R15 R15
lli R10 5
lli R11 20
lli R12 362
lui R12 0
lli R13 460
lui R13 0
jal XSQRF
pop R31
pop R15
pop R14
pop R13
pop R12
pop R11
pop R10
jr R31

// XSQRF prints a filled sqaure on the screen
// Arguments - R10 - X-position upper-left
//             R11 - Y-position upper-left
//             R12 - X-position bottom-right
//             R13 - Y-position bottom-right
//             R14 - outline colour
//             R15 - border colour
:XSQRF
push R10
push R11
push R12
push R13
push R14
push R31
jal XSQR    // print outline
add  R14  R15  R0  // switch outline colour to fill
:XSQRF0
inc  R10
inc  R11
dec  R12
dec  R13    // close box in 1 pixel
brgt R10 R12 XSQRF1
brgt R11 R13 XSQRF1
jal XSQR
br XSQRF0
:XSQRF1
pop  R31
pop  R14
pop  R13
pop  R12
pop  R11
pop  R10
jr   R31

// XSQR prints a square on the screen
// Arguments - R10 - X-position upper-left
//             R11 - Y-position upper-left
//             R12 - X-position bottom-right
//             R13 - Y-position bottom-right
//             R14 - outline colour
:XSQR
push R1
push R2
push R3
push R31
add  R1  R14  R0
add  R2  R10  R0
add  R3  R11  R0
breq R10 R12  XSQRX
breq R11 R13  XSQRY
:XSQRA
jal XVGA
inc R2
brgt R2 R12 XSQR1
br XSQRA
:XSQR1
dec R2
:XSQRB
inc R3
brgt R3 R13 XSQR2
jal XVGA
br XSQRB
:XSQR2
dec R3
:XSQRC
dec R2
brlt R2 R10 XSQR3
jal XVGA
br XSQRC
:XSQR3
inc R2
:XSQRD
dec R3
breq R3 R11 XSQR4
jal XVGA
br XSQRD
:XSQRX
push R11
push R12
push R13
add R12 R11 R0
sub R11 R13 R11
add R13 R14 R0
jal XLNVT
pop  R13
pop  R12
pop  R11
br XSQR4
:XSQRY
push R11
push R12
push R13
sub R11 R12 R10
add R12 R13 R0
add R13 R14 R0
jal  XLNHZ
pop  R13
pop  R12
pop  R11
:XSQR4
pop  R31
pop  R3
pop  R2
pop  R1
jr   R31

//draws oval ball to compensate for screen distortion
//center in xpos in R5 ypos in R6 color in R7
:ZBALL
push R1
push R2
push R3
push R31
add R1 R7 R0
add R2 R5 R0
add R3 R6 R0
dec R2
dec R3
dec R3
dec R3
dec R3
jal XVGA	//row 1
inc R2
jal XVGA
inc R2
jal XVGA
inc R3		//row 2
inc R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
inc R3		//row 3
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R3		//row 4
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
inc R3		//row 5
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R3		//row 6
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
inc R3		//row 7
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R2
jal XVGA
inc R3		//row 8
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
dec R2
jal XVGA
inc R3
inc R2
jal XVGA	//row 1
inc R2
jal XVGA
inc R2
jal XVGA
pop R31
pop R3
pop R2
pop R1
jr R31

// LLNVT prints a vertical line
// Arguments - R10 - X-position
//             R11 - length of line
//             R12 - Y-position of topmost point
//             R13 - line colour
:XLNVT
push R1
push R2
push R3
push R11
push R31
add  R1  R13  R0
add  R2  R10  R0
add  R3  R12  R0
add  R11 R11  R12
:XLNVT0
jal  XVGA
inc  R3
brgt R3  R11 XLNVT1
br  XLNVT0
:XLNVT1
pop  R31
pop  R11
pop  R3
pop  R2
pop  R1
jr   R31

// XLNHZ prints a horizontal line
// Arguments - R10 - X-position of leftmost point
//             R11 - length of line
//             R12 - Y-position of line
//             R13 - line colour
:XLNHZ
push R1
push R2
push R3
push R11
push R31
add  R1  R13  R0
add  R2  R10  R0
add  R3  R12  R0
add  R11 R11  R10
:XLNHZ0
jal XVGA
inc  R2
brgt R2  R11 XLNHZ1
br  XLNHZ0
:XLNHZ1
pop  R31
pop  R11
pop  R3
pop  R2
pop  R1
jr   R31

:XQUIT
nop
nop
stop
